include \masm32\include\masm32rt.inc
include DllDeclare.inc
MbDeflate	PROTO: DWORD, :DWORD, :DWORD
Z_OK=		0
Z_STREAM_END=	1
Z_NEED_DICT=	2
Z_ERRNO=		(-1)
Z_STREAM_ERROR=	(-2)
Z_DATA_ERROR=	(-3)
Z_MEM_ERROR=	(-4)
Z_BUF_ERROR= 	(-5)
Z_VERSION_ERROR=	(-6)
CHUNK =		16384
Z_FINISH =		4
Z_NO_FLUSH =	0
Z_DEFLATED =	8
Z_DEFAULT_STRATEGY = 0

zLibErr MACRO
  .if eax!=Z_OK
	neg eax		; -6=+8, +2=0
	lea eax, [eax*4+8]
	.if eax<=8*4
		print "Error", 9
		print zErrors[eax], 13, 10
	.else
		print str$(eax), " error", 13, 10
	.endif
  .endif
ENDM
void MACRO args
  % @CatStr(<;>, <args>)
ENDM

Z_STREAM STRUC
next_in	dd ?	; pointer to input buffer
avail_in	dd ?	; number of bytes available at next_in
total_in	dd ?	; total nb of input bytes read so far

next_out	dd ?	; pointer to next output byte
avail_out	dd ?	; remaining free space at next_out
total_out	dd ?	; total nb of bytes output so far

msg	dd ?	; last error message, NULL if no error
state	dd ?	; struct internal_state FAR, not visible by applications

zalloc	dd ?	; alloc_func, used to allocate the internal state
zfree	dd ?	; free_func, used to free the internal state
opaque	dd ?	; private data object passed to zalloc and zfree

data_type	dd ?	; best guess about the data type: binary or text
adler	dd ?	; adler32 value of the uncompressed data
reserved	dd ?	; reserved for future use
Z_STREAM ENDS
.data
pStream	dd strm
strm	Z_STREAM <>
zErrors	dd zE0, zE1, zE2, zE3, zE4, zE5, zE6, zE7, zE8 
zE0	db "Z_NEED_DICT", 0	; +2
zE1	db "Z_STREAM_END", 0
zE2	db "Z_OK", 0
zE3	db "Z_ERRNO", 0
zE4	db "Z_STREAM_ERROR", 0
zE5	db "Z_DATA_ERROR", 0
zE6	db "Z_MEM_ERROR", 0
zE7	db "Z_BUF_ERROR", 0
zE8	db "Z_VERSION_ERROR", 0	; -6

.data?
fhandleR	dd ?
fhandleW	dd ?
zerr	dd ?
errmsg	dd 128  dup(?)
align 16
buffer_in	db CHUNK+4 dup(?)
align 16
buffer_out	db CHUNK+4 dup(?)
MAX_WBITS =	15
.code
start:
	Dll "zlib1.dll"
	Declare deflate, C:2
	Declare deflateEnd, C:1
	Declare deflateInit_, C:4	; int deflateInit_(z_streamp stream, int level, * version, int stream_size)
	Declare deflateInit2_, C:8	; int deflateInit_(z_streamp stream, int level, method, bits, level, strategy, * version, int stream_size)
	Declare gzopen, C:2
	Declare gzwrite, C:3
	Declare gzread, C:2
	Declare gzclose, C:1
	Declare inflateInit_, C:1
	Declare inflateInit2_, C:4
	Declare zlibVersion, C:0

	mov strm.next_in, offset buffer_in	; pointer to input buffer
	mov strm.next_out, offset buffer_out	; pointer to output buffer
	mov strm.msg, offset errmsg	; last error message, NULL if no error
;	mov strm.zalloc, HeapAlloc	; alloc_func, used to allocate the internal state
;	mov strm.zfree, HeapFree	; free_func, used to free the internal state
		invoke crt_fopen, chr$("\masm32\include\windows.inc"), chr$("r")
		mov fhandleR, eax
		invoke crt_fopen, chr$("windows.gz"), chr$("w")
		mov fhandleW, eax
		mov ebx, esp
		invoke MbDeflate, fhandleR, fhandleW, 6
		.if ebx!=esp
			mov eax, esp
			print str$(eax), " stac difference", 13, 10
		.endif
		inkey str$(eax), " returned"
	exit
MbDeflate proc hSrcFile, hDestFile, level
LOCAL rval, flush, have, strmDef:Z_STREAM
  call ClearLocVars
  push edi
  push esi
  push ebx
  lea ebx, strmDef
  mov esi, offset buffer_in
  mov edi, offset buffer_out
;  deflateInit2_, 8: int deflateInit_(z_streamp stream, int level, method, bits, memlevel, strategy, * version, int stream_size)
  cmp deflateInit2_(ebx, level, Z_DEFLATED, MAX_WBITS+16, 8, Z_DEFAULT_STRATEGY, chr$("1.2.5"), sizeof strm), Z_OK
  jne RetErr
  .Repeat			;    /* compress until end of file */
	mov strmDef.avail_in, rv(crt_fread, esi, 1, CHUNK, hSrcFile)
	invoke crt_ferror, hSrcFile
	test eax, eax
	jne RetErr
	.if rv(crt_feof, hSrcFile)	; flush = crt_feof(hSrcFile) ? Z_FINISH : Z_NO_FLUSH
		mov flush, Z_FINISH
	.else
		mov flush, Z_NO_FLUSH
	.endif
        mov strmDef.next_in, esi
	.Repeat	        ; run deflate() on input until output buffer not full, finish compression if all of hSrcFile has been read in
		mov strmDef.avail_out, CHUNK
		mov strmDef.next_out, edi
		mov rval, deflate(ebx, flush)	;    no bad return value
;		assert(rval != Z_STREAM_ERROR);  /* state not clobbered */
		mov eax, CHUNK
		sub eax, strmDef.avail_out
		mov have, eax		; have = CHUNK - strmDef.avail_out
		push rv(crt_fwrite, edi, 1, have, hDestFile)
		invoke crt_ferror, hDestFile
		pop edx
;		.if rv(crt_fwrite, edi, 1, have, hDestFile) != have || rv(crt_ferror, hDestFile)
		.if edx != have || eax
			print str$(eax), " error at rep4", 13, 10
			jmp RetErr
		.endif
	.Until strmDef.avail_out		; do ... while (strmDef.avail_out == 0)
;        /* done when last data in file processed */
  .Until flush == Z_FINISH    ; do ... while (flush != Z_FINISH);
; clean up and return
  push Z_OK
  jmp @F
RetErr:
  push Z_ERRNO
@@:
  void deflateEnd(ebx)
  pop eax
  pop ebx
  pop esi
  pop edi
  ret
MbDeflate endp
ClearLocVars proc	; put "call ClearLocals" as first instruction after LOCALS - eax unchanged on exit
  push eax		; do not use with uses esi etc - push them manually behind the call!
  lea eax, [esp+8]		; pushed eax and ret address
  mov esp, ebp		; base page of calling procedure
  align 4		; 74 instead of 123 cycles on Celeron M, no effect on P4
@@:
  push 0		; 120 bytes: 196 cycles on P4
  cmp esp, eax		; rep stosd??
  ja @B
  sub esp, 8		; 19 bytes with align 4
  pop eax
  ret
ClearLocVars endp
end start
RichMasm options
OPT_Tmp2Asm	1
int def(FILE *hSrcFile, FILE *hDestFile, int level)
{
    int rval, flush;
    unsigned have;
    z_stream strm;
    unsigned char in[CHUNK];
    unsigned char out[CHUNK];

    /* allocate deflate state */
    strm.zalloc = Z_NULL;
    strm.zfree = Z_NULL;
    strm.opaque = Z_NULL;
    rval = deflateInit(&strm, level);
    if (rval != Z_OK)
        return rval;

    /* compress until end of file */
    do {
        strm.avail_in = crt_fread(in, 1, CHUNK, hSrcFile);
        if (crt_ferror(hSrcFile)) {
            (void)deflateEnd(&strm);
            return Z_ERRNO;
        }
        flush = crt_feof(hSrcFile) ? Z_FINISH : Z_NO_FLUSH;
        strm.next_in = in;

        /* run deflate() on input until output buffer not full, finish
           compression if all of hSrcFile has been read in */
        do {
            strm.avail_out = CHUNK;
            strm.next_out = out;
            rval = deflate(&strm, flush);    /* no bad return value */
            assert(rval != Z_STREAM_ERROR);  /* state not clobbered */
            have = CHUNK - strm.avail_out;
            if (fwrite(out, 1, have, hDestFile) != have || crt_ferror(hDestFile)) {
                (void)deflateEnd(&strm);
                return Z_ERRNO;
            }
        } while (strm.avail_out == 0);
        assert(strm.avail_in == 0);     /* all input will be used */

        /* done when last data in file processed */
    } while (flush != Z_FINISH);
    assert(rval == Z_STREAM_END);        /* stream will be complete */

    /* clean up and return */
    (void)deflateEnd(&strm);
    return Z_OK;
}
